/*--------------------------------------------------------------------------*/
/*                                                                          */
/* Copyright 1989, Doug Boone.  FidoNet 119/5                               */
/*                              (916) 893-9019 Data                         */
/*                              (916) 891-0748 voice                        */
/*                              P.O. Box 5108, Chico, CA. 95928             */
/*                                                                          */
/* This program is not for sale. It is for the free use with Opus systems.  */
/* You may not sell it in ANY way. If you have an access charge to your     */
/* Bulletin Board, consider this to be like Opus, you can ONLY make it      */
/* available for download in an open area, where non-members can get access */
/*                                                                          */
/* If you need to modify this source code, please send me a copy of the     */
/* changes you've made so that everyone can share in the updates.           */
/*                                                                          */
/* "Don't rip me off!" -- Tom Jennings, FidoNet's founder                   */
/*                                                                          */
/*--------------------------------------------------------------------------*/

#ifdef TURBOC
#define cdecl _Cdecl
#endif

#define     MAX_NAMES   256

struct  names   {		/* Used for unpacking files */
    char                name[14];
    unsigned    int     size;
};
/*--------------------------------------------------------------------------*/
/* Constants for FVIEW.C, global data                                       */
/*--------------------------------------------------------------------------*/

extern  struct  names   member[];		/* Table of members of archive */
extern  int     mem_used;       		/* Number of members in table */

extern  int     port;		/* Which Comm port is active (COM1: = 0) */
extern  int     baud;		/* Baud if online */
extern  int		task;		/* Which Opus task is running */
extern  int     flags;		/* Tells about what user wants, see FVIEW.H */
extern  int		screen;		/* User's screen height from LASTUSER.BBS */
extern  int     ctrl_err;		/* CTRL-BREAK error results */
extern  int     line;		/* Current line on screen */
extern  long    dearc_free;		/* Free disk space on dearcing drive */
extern  long	quit_time;		/* When user has to be offline in seconds */
extern  char	apath[MAX_PATH];
extern  char    file_path[MAX_PATH];		/* Where's FILES */
extern  char	mbr_path[MAX_PATH];		/* The full member path with name */
extern  char    dearc_path[MAX_PATH];		/* Where to put unarchived files */
extern  char	mbr[20];		/* Member name */
extern  FILE    *Log_fp;		/* FVIEW.LOG */


#define     MAX_NAMES   256		/* Used with member[] */

/*--------------------------------------------------------------------------*/
/* In FOSCOM.C                                                              */
/*--------------------------------------------------------------------------*/

extern  int		GetDriverInfo(void);
extern  int		CkFossilCD(void);
extern  int 	Com_(unsigned,unsigned);
extern  int 	Comm_Set_Baud(int,int,int,int);
extern  void 	Comm_transmit(int);
extern  int 	Comm_Receive(void);
extern  int 	Get_Comm_Status(void);
extern  int 	Comm_Char_Avail(void);
extern  int 	Comm_Init(int,int,int,int);
extern  void 	Comm_De_Init(void);
extern  void 	Comm_Dtr(int);
extern  void 	Comm_flush_out(void);
extern  void 	Comm_Purge_out(void);
extern  void 	Comm_Purge_in(void);
extern  void 	Comm_Watch(int);
extern  char 	Comm_Peek(void);
extern  int 	Comm_CD(void);

extern  int 	locputs(register char *);
extern  int 	fosputs(register char *);
extern  int 	play(const char *,...);
extern  void 	sendbyte(byte);

/*--------------------------------------------------------------------------*/
/* In ARC_VIEW.C                                                            */
/*--------------------------------------------------------------------------*/

void     arc_header(char *,char *);
void	one_line(char *,long,long,char *,char *, char *);
void	do_totals(int,long,long,int);
int 	lstarc(char *);
int 	do_zoo(char *);
char*   cdecl      memrstr(char *,char *,int);
int     cdecl      read_dwc(char *);
int 	do_zip(char *);
int     read_lzh(char *);

/*--------------------------------------------------------------------------*/
/* In FVIEW.C                                                               */
/*--------------------------------------------------------------------------*/

extern  void	get_path(char *);
extern  void	load_fossil(void);
extern  void	terminate(int);
extern  void	file_name(char *);
extern  void    short_list(char *);
extern  int 	get_names(void);
extern  void	handler(void);
extern  void	help(void);
extern  int		get_mbr_name(char *);
extern  int 	show_file(char *,char *);
extern  void	list_file(char *);
extern  int 	validate(char *,char *);
extern  void    get_string(char *);

extern  int  (cdecl * cdecl sdisplay)(char *);	/* ptr to display function */
extern  int  (cdecl * cdecl get_a_char)(void);	/* instead of getch()	*/
extern  int  (cdecl * cdecl chk_keyboard)(void);	/* instead of kbhit()	*/

#ifdef TURBOC
#undef cdecl
#endif


