%                DRLINK v2.20 Sample control file

% Doorlink Control File. Very Similiar in Format to OPUS.CTL file You must
% Use Key Words (IE, Modem, Sysop) in the same fashion you do your
% OPUS.CTL file. This File -must- be compiled with DRLK_CTL.EXE each time it
% is changed.

% These Lines are REQUIRED:

Modem COM1
Sysop Chris Holten
System C's Doghouse

% Amount of time you want to allow users on in DOORS for a single session
% and total time per day.  This *Must* be in the format PER SESSION and
% MAXIMUM TIME Per Day in  minutes..Similiar Principle to OPUS. This is 
% optional for OPUS 1.10 users and -NOT- optional for OPUS 1.03 users.

%         Time per session  Max time per Day
TWIT           15                15
DISGRACE       45                45
NORMAL         60                60
PRIVEL         60                90
EXTRA          90                180
ASSTSYSOP      120               180
TSYSOP         180               300
^ NOTE the T in front of SYSOP to designate the time allowed the
% Sysop!!

% The rest of this stuff is OPTIONAL.

% Tell DRLINK which USER.BBS file you want updated with OUTSIDE time.
% The user.bbs file won't be updated unless you use UPDATEUSER 
% /Boutiside.bat on the DRLINK command line. _NEVER_ update the USER.BBS 
% file if you are running DRLINK with a shell from OPUS. Only update the 
% USER.BBS file when you run DRLINK as an O)utside EXIT <errorlevel> 
% from Opus. If you don't understand what I am talking about put a % in 
% front of UserBBS.

UserBBS E:\Opus103\USER.BBS

% The Name of the file you want DRLINK to write a log too. If you don't 
% want a log, then put a % in front of DLOG

DLOG E:\Opus\DRLINK.LOG

% Take a walk on the wild side. This works with a CPI 9600 baud modem 
% with the baud locked at 38400. Can't garantee it will work with yer 
% HST or favorite FOSSIL. If you uncomment LOCKBAUD, then instead of 
% automatically detecting the baud rate on the comport, DRLINK will set 
% the baud to the LOCKBAUD Rate. You really don't need to use LOCKBAUD 
% unless you want to use the MAXDOORBAUD to limit the baud rate setting 
% that doorlink runs the doors at. If you use MAXDOORBAUD then doorlink 
% will run the doors at the CONNECT baud rate of the user or the 
% MAXDOORBAUD rate, whichever is less. It only will work in MENU mode. 
% When the door is exited, and the user returns to the DRLINK MENU, the 
% baud rate will be returned to the LOCKBAUD rate before exiting back to 
% OPUS. If it works for you, this feature will allow you to lock your 
% baud rate at 19200 or 38400 baud and run doors that are only capable 
% of running up to MAXDOORBAUD. It can also cure a raft of device timeout 
% problems with fast computers running at high baud rates -IF- the modem, 
% Like a CPI modem, can handle changes in input baud rate with out going 
% out into Ga-Ga land with the CONNECT baud rate.

LockBaud 38400
MaxDoorBaud 9600

% Set up the Event's you have scheduled that you want to Force
% user off line with. You don't need any other event's. Use 24
% hour time.(HH:MM), 10 events Maximum. Order is not important. If you 
% have to have a midnite event, make it 23:59 or 00:01. 00:00 won't be 
% recognized.

EVENT 03:00
END
% You -Must- Have End immediately after the event setup if you are going
% to have -any- EVENT's

% Building a SpawnDor.bat file.... You need this ONLY if you want to run
% QuickBBS Doors that require a command line or if you are running
% the drlink MENU. In both cases these are the commands to exit back to
% you bulletin board after the user is finished with DOORS.

% A file will be written called spawndor.bat.  The batch file will contain
% the commands needed to change to the proper drive and directory and
% fire up QuickBBS DOORS with the necessary command line switches.  You are
% allowed 12 lines after the command to execute what ever else you need to
% before exiting Back to OPUS.  The SpawnDor.bat file will always be ended
% with an EXIT command.  That is done in addition to what ever lines you
% want to include in the SpawnDor.bat below.  I really doubt that you will
% ever need more than 12 batch file lines after running a Door from OPUS.
% I just included them incase you come up with something I hadn't
% anticipated.  If you don't need these extra lines, then delete them.
% START it out with START SPAWNDOR and END SPAWNDOR to let DRLK_CTL know the
% spawndor setup is finished.

START SPAWNDOR
chk4ddos
if errorlevel 1 goto DDOS
goto FINISH
:DDOS
FOSIL F0
resume
send *
:FINISH
set DOORPCH=
set LIB=
CD \OPUS
END SPAWNDOR

% You -must- have END SPAWNDOR immediately after the spawndor setup if 
% you are going to have any Spawndor.bat commands.

% Set up DRLINK to adjust time based on good uploaders. This is a ratio
% that the time left on OPUS will be multiplied by to adjust a users
% time according to his Upload Quantity. To use these ratios you must also
% use /U command line switch. It is in the form UL [Amount less than] [Ratio]

UL 0 .5
UL 100 .7
UL 200 .8
UL 300 .9
UL 400 1.0
UL 1000 1.5
END

% You -must- have END immediately after the UL listing if you are going
% to have UL settings.

% In this example a user that has uploaded 0 to 100k would have his DOOR
% Door time Dropped to 50% of the time left on the system. A user that has
% uploaded 100 to 200 k would be allowed 70% of the remaining time he has
% left on OPUS etc.


% and now my favorite part....

% The DRLINK Menu. It is only necessary if you are running DRLINK MENU.

% Doorlink menu data. The format is:
%
% Designator, Subsystem Command, Execute Command, Game Description, Prival
%
%  Where:
%     Designator - Key(s) for user to push to select game, Can be
%                  and combination of numbers and letters, except X. X
%                  is for eXit. The menu makes more sense if you make
%                  your designators in descending order by prival level
%                  if you have different privals.
%
%     Subsystem Command - Drlink Subsystem command, same designation as
%                         when using non-menu command line.
%
%                         /Qe:\doors   Would write a QuickBBS
%                                      DORINFO1.DEF in the e:\doors
%                                      directory
%
%     Non-Door Command   /-c:\dos      The - will allow the running of
%                                      any external program that isn't
%                                      one of the BBS Subsystems
%                                      Doorlink writes files for (IE
%                                      drop to DOS with DOORWAY in the
%                                      example menu).
%
%     Execute Command - Command to execute door:
%
%                         TWQ.EXE DORINFO1.DEF  is the command line
%                                               required to run Trade
%                                               Wars v 9.03
%
%     Game Description - The Game Description you want your users to see
%     on the MENU
%
%     Privil - The minimum OPUS Prival to use DOOR. The value is based
%     on OPUS 1.10 Privals (-NOT- 103). The Minimum Prival is NORMAL (80) by
%     Default.
%
%      Prival values are:
%              SySop     =  208
%              AssSySop  =  176
%              Extra     =  144
%              Privil    =  112
%              Normal    =  80
%              Disgrace  =  48
%              Twit      =  16
%
% All Menu Commands -must- be separated by a Comma. You can set up a
% Maximum of 100 games.
%
% You -have- to have MENU at the top of the menu and END at
% the bottom of the menu setup if want DRLINK to display a menu. You
% cannot put any other statements between the MENU and END or you
% will screw drlink up. Don't forget to use commas to separate the menu
% selections or DRLK_CTL will screw up. The MENU set up must be the
% -last- setup in the DRLINK.CTL file.
%
%
MENU
1, /Qe:\doors\, TWQ.EXE DORINFO1.DEF, Trade Wars 1000, 16, 30
2, /Pe:\doors\motu, baybull bsb.cfg, Bay Street Bulls, 48, 30
3, /4e:\doors\pcb14, barons 1 e:\doors\pcb14\ pcboard14, Barron Midevil Adventure, 48
4, /Ge:\gap, LEECH e:\gap,Leech Hackers Game, 48, 0
5, /Pe:\doors\motu\, yahtzee yahtzee.cfg, Yahtzee, 48
6, /Pe:\doors\motu, poker20a casino.cfg,  Poker, 48
7, /Pe:\doors\motu, craps20a casino.cfg, Craps, 48
8, /Pe:\doors\motu, rlet20a casino.cfg,  Roulette, 48
9, /4e:\doors\pcb14, Tchess TCH.CFG, Chess, 48
10, /pe:\doors\tw500, guppies guppies.cfg, Card Guppies, 48
11, /oe:\opus, c:\opus\waka c:\opus\krammail.exe, Check for new mail, 48,
12, /pe:\opus, doorway com1 /O: /E: /S:E:\Opus\ /Pc:\Opus\bbsphone.com, Bulletin Board Data Base, 48,
13, /4e:\doors\pcb14, batdoor batdoor.cfg, Battleship, 48
14, /Oe:\opus, c:\opus\waka c:\opus\krammail.exe, Read your mail, 48, 0
15, /Pe:\doors\motu, sidroid pcboard.sys 1, [Semi] Intelligent Droids, 48, 30
98, /-c:\, Command.com, Local drop to DOS, 208
99, /Pe:\Opus , doorway com1 /K:0 /O: /G: /S:E:\Opus\ /C:DOS, DoorWay Drop to DOS, 208
END
%
% If you have some wierd things happen with your MENU setup, take a look 
% at the SPAWNDOR.BAT file drlink writes. It will help to understand how 
% the MENU setup relates to the SPAWNDOR.BAT file.
%
%
