/*--------------------------------------------------------------------------*/
/*                                                                          */
/* Copyright 1989, Doug Boone.  FidoNet 119/5                               */
/*                              (916) 893-9019 Data                         */
/*                              (916) 891-0748 voice                        */
/*                              P.O. Box 5108, Chico, CA. 95928             */
/*                                                                          */
/* This program is not for sale. It is for the free use with Opus systems.  */
/* You may not sell it in ANY way. If you have an access charge to your     */
/* Bulletin Board, consider this to be like Opus, you can ONLY make it      */
/* available for download in an open area, where non-members can get access */
/*                                                                          */
/* If you need to modify this source code, please send me a copy of the     */
/* changes you've made so that everyone can share in the updates.           */
/*                                                                          */
/* "Don't rip me off!" -- Tom Jennings, FidoNet's founder                   */
/*                                                                          */
/*--------------------------------------------------------------------------*/


#ifdef TURBOC
#define cdecl _Cdecl
#endif

/*--------------------------------------------------------------------------*/
/* Global data for FVIEW.EXE                                                */
/*--------------------------------------------------------------------------*/

int     port = 0;		/* Which COM port is active. COM1 = 0! */
int     baud = 2400;		/* Online baud rate */
int     task = 1;		/* Which task to use */
int     flags = 0;		/* User flags. What does the user want? */
int     screen = 24;		/* Height of the user's screen */
int     ctrl_err = 1;		/* Ctrl-C returns */
int     line = 0;		/* Which line is currently active */
long    dearc_free;		/* Amount of free disk space in dearc directory */
long    quit_time;		/* When to push the user back to Opus, Seconds */
char    apath[MAX_PATH];
char    file_path[MAX_PATH];		/* Current download directory */
char    mbr_path[MAX_PATH];		/* Full path including archive name */
char    dearc_path[MAX_PATH];		/* Where un-archived files will go */
char    Sys_Path[MAX_PATH];		/* Path to SYSTEM*.BBS file */
char    mbr[20];		/* archive member */
struct  _usr    last[1];
FILE    *Log_fp;		/* FVIEW log file */
/* Used when unpacking files */
int     infile;
int     outfile;
byte    *inbuf;
byte    *inptr;
byte    *outbuf;
byte    *outptr;
unsigned    inpos = 0;
unsigned    outpos = 0;
long		packed;
long        unpacked;
unsigned    insize;
unsigned    outsize;


#define     MAX_NAMES   256

struct  names   {        /* Used for unpacking files */
    char                name[14];
    unsigned    int     size;
};

struct  names   member[MAX_NAMES];
int     mem_used;

/*--------------------------------------------------------------------------*/
/* In FOSCOM.C                                                              */
/*--------------------------------------------------------------------------*/

extern  int        GetDriverInfo(void);
extern  int        CkFossilCD(void);
extern  int     Com_(unsigned,unsigned);
extern  int     Comm_Set_Baud(int,int,int,int);
extern  void     Comm_transmit(int);
extern  int     Comm_Receive(void);
extern  int     Get_Comm_Status(void);
extern  int     Comm_Char_Avail(void);
extern  int     Comm_Init(int,int,int,int);
extern  void    Comm_De_Init(void);
extern  void    Comm_Dtr(int);
extern  void    Comm_flush_out(void);
extern  void    Comm_Purge_out(void);
extern  void    Comm_Purge_in(void);
extern  void    Comm_Watch(int);
extern  char    Comm_Peek(void);
extern  int     Comm_CD(void);

extern  int     locputs(register char *);
extern  int     fosputs(register char *);
extern  int     play(const char *,...);
extern  void    sendbyte(byte);

/*--------------------------------------------------------------------------*/
/* In ARC_VIEW.C                                                            */
/*--------------------------------------------------------------------------*/

extern  void     arc_header(char *,char *);
extern  void    one_line(char *,long,long,char *,char *, char *);
extern  void    do_totals(int,long,long,int);
extern  int     lstarc(char *);
extern  int     do_zoo(char *);
extern  char*   cdecl      memrstr(char *,char *,int);
extern  int     cdecl      read_dwc(char *);
extern  int     do_zip(char *);
extern  int     read_lzh(char *);


/*--------------------------------------------------------------------------*/
/* In FVIEW.C                                                               */
/*--------------------------------------------------------------------------*/

void    get_path(char *);
void    parse_env(char *,char *);
void    load_fossil(void);
void    terminate(int);
void    file_name(char *);
void    short_list(char *);
int     get_names(void);
int     do_wild(char *, char *);
void    handler(void);
void    help(void);
void    list_help(void);
int     get_mbr_name(char *);
void     show_file(char *,char *);
void    list_file(char *);
int     validate(char *,char *);
void    get_string(char *);
char *  get_next(char *);
void    check_cfg(char *);

int  (cdecl * cdecl sdisplay)(char *);    /* ptr to display function */
int  (cdecl * cdecl get_a_char)(void);    /* instead of getch()    */
int  (cdecl * cdecl chk_keyboard)(void);    /* instead of kbhit()    */

#ifdef TURBOC
#undef cdecl
#endif

